package EDU.auburn.VGJ.frontend;

import EDU.auburn.VGJ.graph.*;
import EDU.auburn.VGJ.gui.*;
import webflow.backend.*;
import webflow.frontend.*;
import webflow.frontend.ModuleControls.CPanel;
import java.util.*;
import java.net.*;
import java.io.*;

public class compgraph {

  private NodeList List;
  private Node  node;
  private int   imax;
  private int    i,j;
  private int idx,id;
  private int   nedg;
  private String moduleName;
  String smURL;
  GraphWindow GW;
  Hashtable edges;
  int ntotal;
  String hostName;
  String ClientID;
  int portNumber;
  CPanel am;
  Hashtable moduleClass;
  compnode[] CompNodeList;
  compnode Cnode, fromCnode, toCnode;

  private SMreply _smreply;
  private SMreply _connect;
  private ID fromPort, toPort, fromModule, toModule;
  private String dir;

  public compgraph(GraphWindow GW_, NodeList NodeList_, Hashtable Edges_, String SM_URL) {
    List = NodeList_;
    smURL = SM_URL;
    GW = GW_;
    edges = Edges_;
    CompNodeList = new compnode[15];

    /*
    moduleClass = new Hashtable(15);
    moduleClass.put("EditFile","webflow.modules.QuantumSimulations.EditFile");
    moduleClass.put("FileBrowser","webflow.modules.QuantumSimulations.FileBrowser");
    moduleClass.put("FileName","webflow.modules.QuantumSimulations.FileName");
    moduleClass.put("GetFile","webflow.modules.QuantumSimulations.GetFile");
    moduleClass.put("PutFile","webflow.modules.QuantumSimulations.PutFile");
    moduleClass.put("Gaussian","webflow.modules.QuantumSimulations.GAUSSIAN");
    moduleClass.put("Gamess","webflow.modules.QuantumSimulations.GAMESS");
    moduleClass.put("Gaus2pdb","webflow.modules.QuantumSimulations.GAUS2PDB");
    moduleClass.put("Gaus_monitor","webflow.modules.QuantumSimulations.GAUS2PDB");
    moduleClass.put("GRAM","webflow.modules.QuantumSimulations.GRAM");
    System.err.println("Test hash: "+(String)moduleClass.get("Gamess"));
    */
  }


  public void tomnodelist () {


    System.err.println("======== RUN: START PROCESSING============");
    System.err.println("==========================================");


    imax = List.count();
    hostName = GW.hostName;
    ClientID = GW.ClientID;
    portNumber = GW.portNumber;   
    am = GW.tomPanel.Executor;
    ntotal=0;
    String modulePath = "webflow.modules.QuantumSimulations.";
    ID portID = null;

    if(imax>0) {
      node = List.firstNode();
      moduleName=node.getLabel();
      dir=node.getModuleDir();
      node.ModuleClassPath=GW.tomPanel.currModules.getModuleClass(moduleName,dir);
      String classfrommodules = node.ModuleClassPath;
      _smreply=requestInit(classfrommodules);

      System.err.println(":::: "+moduleName);
      System.err.println("++++ "+classfrommodules);
      System.err.println("moduleWebID: "+(_smreply.getModuleID()).getInt());
      System.err.println("-------- returned from requestInit ------------");

      Vector tmpPortList = _smreply.getPortList();
      int tmpListLenght = tmpPortList.size();
      System.err.println("#### number of ports: "+tmpListLenght);
      for (j=0;j<tmpListLenght;j++) {
         ID tmpPortID = (ID) tmpPortList.elementAt(j);
         System.err.println("port # "+j+" id="+tmpPortID.getInt());
      }

      node.setBackendInfo(_smreply.getModuleID(),_smreply.getPortList()); 

      if(imax>1) {
       for(i=1;i<imax;i++) {
          node = List.nextNode(node);
          moduleName=node.getLabel();
          node.ModuleClassPath=GW.tomPanel.currModules.getModuleClass(moduleName,dir);
          classfrommodules = node.ModuleClassPath;         
          _smreply=requestInit(classfrommodules);
 
      System.err.println(":::: "+moduleName);
      System.err.println("++++ "+classfrommodules);
      System.err.println("moduleWebID: "+(_smreply.getModuleID()).getInt());
      System.err.println("-------- returned from requestInit ------------");

      tmpPortList = _smreply.getPortList();
      tmpListLenght = tmpPortList.size();
      System.err.println("#### number of ports: "+tmpListLenght);
      for (j=0;j<tmpListLenght;j++) {
         ID tmpPortID = (ID) tmpPortList.elementAt(j);
         System.err.println("port # "+j+" id="+tmpPortID.getInt());
      }

      node.setBackendInfo(_smreply.getModuleID(),_smreply.getPortList()); 
      }
     }

      System.err.println("... now Edges ...");
      
      Enumeration active_edges = edges.keys();
      while(active_edges.hasMoreElements())
	{
         SDPoint currEdge = (SDPoint)(active_edges.nextElement());
         System.err.println(".........next edge......");
     
         System.err.println("SRCE : "+currEdge.dest_);
         System.err.println("DEST : "+currEdge.source_);
         System.err.println("INT DEST : "+currEdge.intSource);
         System.err.println("INT SRCE : "+currEdge.intDest);
         System.err.println("HEAD : "+currEdge.head_);
         System.err.println("TAIL : "+currEdge.tail_);

         Node fromNode = List.nodeFromIndex(currEdge.head_);
         ID fromNodeWFid = fromNode.WFid;
         System.err.println("fromNode ID: "+fromNodeWFid.getInt()); 
         Node toNode = List.nodeFromIndex(currEdge.tail_);
         ID toNodeWFid = toNode.WFid;
         System.err.println("  toNode ID: "+toNodeWFid.getInt()); 

	 /*
         there is a convention: output ports first, then input ports
         FE ports ID: input 1,2,3;   output: 101,102,103
                      DESTINATION    SOURCE
         */
         System.err.println("... find ports ID ...");

         // first output ports of fromNode  ("fromPort")

      int FEfromPort = currEdge.intDest;
      System.err.println("FrontEnd ID of output port: "+FEfromPort);
      FEfromPort -= 101;
      System.err.println("corrected FE ID of output port: "+FEfromPort);
      ID fromPort = (ID) fromNode.WFportList.elementAt(FEfromPort);
      System.out.println("fromPort: "+fromPort.getInt());

         // then input ports of toNode ("toPort")

      int FEtoPort = currEdge.intSource;
      System.err.println("FrontEnd ID of input port: "+FEtoPort);
      System.err.println("corr "+GW.tomPanel.currModules.getNumberOutPorts(moduleName,dir));
      FEtoPort += GW.tomPanel.currModules.getNumberOutPorts(moduleName,dir);
      ID toPort = (ID) toNode.WFportList.elementAt(FEtoPort);
      System.out.println("toPort: "+toPort.getInt());

      /*
	          ID fromPort = (ID)(List.nodeFromIndex(currEdge.head_))
                       .WFportList.elementAt(currEdge.intSource-1 +
           GW.tomPanel.currModules.getNumberOutPorts(moduleName,dir));

         ID toPort = (ID)(List.nodeFromIndex(currEdge.tail_))
                             .WFportList.elementAt(currEdge.intDest-101);
         System.out.println("  toPort: "+toPort.getInt());
	 */

          _connect=connect(fromPort, toPort, fromNodeWFid,toNodeWFid);
   
	} 
     
      /*
      int NumberOfNodes = imax;
      for(i=0;i<NumberOfNodes;i++) { 
        fromCnode=CompNodeList[i];
        node=fromCnode.mynode;
        moduleName=node.getLabel();
        System.err.println("module name: "+moduleName);
        nedg = node.numberOfChildren();
        System.err.println("current value of i :"+i+" edges "+nedg);
        if(nedg>0) { 
          idx = node.firstChild();
          toCnode=CompNodeList[idx];
          System.err.println("Edge "+i+"->"+idx);
          System.err.println("ports: "+(ID)fromCnode.WFportList.elementAt(0));
          System.err.println("ports: "+(ID)toCnode.WFportList.elementAt(1));
	  //        portID =(ID)portList.elementAt(i);
          _connect=connect((ID)fromCnode.WFportList.elementAt(0),
                           (ID)toCnode.WFportList.elementAt(1),
                           fromCnode.WFid,toCnode.WFid);
	}
        if(nedg>1) {
	 for(j=1;j<nedg;j++) {
         idx = node.nextChild();
         System.err.println("Edge 0->"+idx);
          toCnode=CompNodeList[idx];
          System.err.println("Edge "+i+"->"+idx);
	  //        portID =(ID)portList.elementAt(i);
          _connect=connect((ID)fromCnode.WFportList.elementAt(0),
                           (ID)toCnode.WFportList.elementAt(1),
                           fromCnode.WFid,toCnode.WFid);
	 }
	}      
      }
      */
    }

   System.err.println("connections done - now runit");
   SMreply runnit=runModules();
  }
  // adopted from WebEeditor

  /**
  * <ol>
  *  <li> Open an Url connection to the SessionManager Object
  *  <li> Tell her your ClientId, new_module request and the name of the module.
  *  <li> Wait its response.
  *  <li> If the first word of first line is OK, this means that 
  *       she got the message and everything is ok. Then read the
  *       port number from the second line to read the result of the
  *       operation.
  * </ol>
  *
  */

  SMreply 
  requestFromServer(String request)
  {

    SMreply reply = null;
    int current_portNumber = -1;

    if(request==null) return null;

    try
    {
      System.err.println("start requestFromServer");
      //Added by Erol for chache problem
      Date dt = new Date ();
      String tmp = Long.toString(dt.getTime());
      request = request+"&time="+tmp;
      System.err.println("request: "+request);
           
      URL myReq = new URL(request);
      
      try
      {
        DataInputStream dis = new DataInputStream( myReq.openStream() );
        
        String status = dis.readLine();
        StringTokenizer STstatus = new StringTokenizer(status);
        
   System.err.println(" I read status :"+status);

        if( STstatus.countTokens() > 0 &&  
            STstatus.nextElement().equals("OK")  )
        {
          String SportNumber = dis.readLine();
          System.err.println(" I read SportNumber:"+SportNumber+"|");
          
          current_portNumber = Integer.parseInt(SportNumber); 

        } else return reply;

      } catch ( IOException e)
        {
           System.err.println("IOException is raised!");
           e.printStackTrace();
           return reply;
        }

    } catch ( MalformedURLException mue)
      {
        System.err.println(" MalformedURLException is raised!");
        mue.printStackTrace();
        return reply;
      } 
 
    /** If port number is invalid exit */
    if( current_portNumber < 1 ) return reply;

    System.err.println("port number seems to be OK");

    Socket Csocket = null;
    DataInputStream  Cdin  = null;
    DataOutputStream Cdout = null;

    try
    {
      Csocket = new Socket(hostName, current_portNumber );

      Cdin = new DataInputStream( Csocket.getInputStream() );

      Cdout = new DataOutputStream( Csocket.getOutputStream() );

    } catch( UnknownHostException e)
      {
         System.err.println("UnknownHostException" + e +" raised!");
         e.printStackTrace(); 
         return reply;
      }
      catch( IOException e)
      {
         System.err.println("IOException (2)" + e + " raised!");
         e.printStackTrace(); 
         return reply;
      }
       
    System.err.println("create empty reply");   
    reply = new SMreply();
    System.err.println("created empty reply");   

    try
    {
      reply.fromStream(Cdin);
      System.err.println("got reply?"); 

      if(reply.getStatus() == SMreply.ERROR) 
       	System.err.println( reply.getDescription());

    } catch( NullPointerException e)
      {
         System.err.println("NullPointerException vo requestInit" + e);
         e.printStackTrace();
         return null;
      }

    System.err.println("ready to return from requestFromServer");
    return reply;

  }// end of requestFromServer()

  /**
  * Initialize the module
  */
  public SMreply 
  requestInit(String moduleClassName)
  //  requestInit(ModuleTreeItem m)
  { 
     String myreq = new String(smURL+"?cmd=new_module&ClientID="+
                               ClientID+"&name="+moduleClassName);

     System.err.println("req(InitModule):"+ myreq);


     ntotal++;
     if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");}
     int lastdot = moduleClassName.lastIndexOf(".")+1;
     String mname = moduleClassName.substring(lastdot);
     System.out.println("---> HASH of "+mname);
     Integer r1 = (Integer)am.lp.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         am.addNewModule(ntotal,r2,mname);
     }
     else {
        am.addNewModule(ntotal,0,mname);
     }

     System.out.println("End of requestInit ");

     return requestFromServer(myreq); 

  }// end of requestInit()


  /**
  */
  public SMreply
  connect(ID from, ID to, ID fromModule, ID toModule )
  {
    String req = new String(smURL+"?cmd=connect&ClientID="+ClientID);
    req += "&fromStr="+from.getString();
    req += "&fromVal="+from.getInt();
    req += "&toStr="+to.getString();
    req += "&toVal="+to.getInt();
    req += "&mIDfromStr="+fromModule.getString();
    req += "&mIDfromVal="+fromModule.getInt();
    req += "&mIDtoStr="+toModule.getString();
    req += "&mIDtoVal="+toModule.getInt();

    return requestFromServer( req );

  }// end of connect()

  /**
  * Runs all the modules in the current session
  */
  public SMreply
  runModules()
  {
     String req = new String(smURL+"?cmd=run_modules&ClientID="+ClientID);

     return requestFromServer(req);

  }// end of run()

  /**
  * public version of SMreply destroy that is void (TH)
  */

  public void destroyAll() {
  _smreply = destroy();
  }    

  /**
  * Destroys all the modules in the current session
  */
  public SMreply
  destroy()
  {
    am.clean();
    ntotal=0;
    

     String req = new String(smURL+"?cmd=destroy_modules&ClientID="+ClientID);

     SMreply rett= requestFromServer(req);

     if( rett == null ) 
         rett = new SMreply(SMreply.ERROR,"Unkown");

     return rett ;

  }// end of destroy()


}






