package EDU.auburn.VGJ.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import webflow.frontend.ModuleControls.CPanel;
import EDU.auburn.VGJ.frontend.*;

public class CardPanel extends Panel implements ActionListener, ItemListener {

   GraphWindow GWindow;
   GraphCanvas GraphCanvas_;
   CardLayout card = new CardLayout();
   CardLayout Acard = new CardLayout();
   Checkbox LoadIt, EditIt, SaveIt, RunIt, StopIt, ExitIt;
   Panel Modules, ActionCards;
   public CPanel Executor;
   //Erol
   public Modules currModules;
  //Erol
   String sm_URL;
   compgraph compgraph_;

   private int i,ii;
   private String moduleName;
   String dirName;   

  CardPanel(GraphWindow GraphWindow_,GraphCanvas GCanvas, String SM_URL) {
      super();
      sm_URL = SM_URL; 

      //Erol
      //SM_URL, ClientID, hostName, moduleListURL,portNumber comes from
      //GraphWindow_;
      currModules = new Modules(GraphWindow_.moduleListURL);
      //Erol

      GWindow = GraphWindow_;
      GraphCanvas_ = GCanvas;
      setLayout(new BorderLayout());

      Panel Action = new Panel();
      Action.setLayout(new GridLayout(2,3));
      Action.setBackground(Color.blue);
      Action.setForeground(Color.yellow);
      CheckboxGroup actiongroup = new CheckboxGroup();
      LoadIt = new Checkbox("Load", false, actiongroup);
      EditIt = new Checkbox("Edit", true, actiongroup);
      SaveIt = new Checkbox("Save", false, actiongroup);
      RunIt  = new Checkbox("Run", false, actiongroup);
      StopIt = new Checkbox("Stop", false, actiongroup);
      ExitIt = new Checkbox("Exit", false, actiongroup);

      ItemListener ActBox = new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
	    String what = e.getItem().toString();
            System.err.println("checkbox selected: "+what);
            if(what.equals("Run")) {
                compgraph compgraph_ = 
                  new compgraph(GWindow,GraphCanvas_.graph_.nodeList_,
                    GraphCanvas_.graph_.edges_,sm_URL);
                compgraph_.tomnodelist();
	    }
            if(what.equals("Stop")) {
              if(compgraph_ != null) {compgraph_.destroyAll();}
            }
            if(what.equals("Exit")) {
              if(compgraph_ != null) {compgraph_.destroyAll();}
              GWindow.dispose();
            }
            showActionCard(what);
         }
      };

      LoadIt.addItemListener(ActBox); 
      EditIt.addItemListener(ActBox); 
      SaveIt.addItemListener(ActBox); 
      RunIt.addItemListener(ActBox); 
      StopIt.addItemListener(ActBox); 
      ExitIt.addItemListener(ActBox); 

      Action.add(LoadIt); Action.add(EditIt); Action.add(SaveIt);
      Action.add(RunIt); Action.add(StopIt); Action.add(ExitIt);
      add(BorderLayout.NORTH,Action);

      ActionCards = new Panel();
      ActionCards.setLayout(Acard);

      Panel Creator = new Panel();
      Creator.setLayout(new BorderLayout());

      Panel superApp = new Panel();
      superApp.setBackground(Color.cyan);
      superApp.setLayout(new GridLayout(3,1));
      Font titleFont = new Font("Serif",Font.BOLD,14);
      Label AAA = new Label("Applications", Label.CENTER);
      Label BBB = new Label("Modules", Label.CENTER);
      AAA.setFont(titleFont);
      BBB.setFont(titleFont);

      Panel Applications = new Panel();

      int nd = currModules.getNumberOfDir();

      if(nd<5) {
        Applications.setLayout(new GridLayout(1,nd));
      }
      else if(nd<9) {
        Applications.setLayout(new GridLayout(2,4));
      }
      else {
        Applications.setLayout(new GridLayout(3,4));
      }

      Button[] ButtonsA;
      ButtonsA = new Button[nd]; 

      ActionListener AppButList = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            String what = e.getActionCommand().toString();
            dirName = what;
            showContents(what);
         }
      };

      for(i=0;i<nd;i++) {
        ButtonsA[i] = new Button(currModules.getDirName(i));
        ButtonsA[i].addActionListener(AppButList);
        Applications.add(ButtonsA[i]);
      }

      superApp.add(AAA);
      superApp.add(Applications);
      superApp.add(BBB);
      
      Creator.add(BorderLayout.NORTH,superApp);

      Modules = new Panel();
      Modules.setLayout(card);

      //cards with modules (one card for each directory=ButtonA[i])
      
      Panel[] PanelM;
      PanelM = new Panel[nd];

      for(i=0;i<nd;i++) {

        PanelM[i] = new Panel();
        String dname = currModules.getDirName(i);
        dirName = dname;
        int nbuttons = currModules.getDirSize(dname);
        PanelM[i].setLayout(new GridLayout((nbuttons-1)/2+1,2));
        
        Button[] buttonsM = new Button[nbuttons];
        String[] buMnames = new String[nbuttons];

        Vector ModList = currModules.getModuleList(dname);

        ActionListener QSlistener = new ActionListener() {
          public void actionPerformed(ActionEvent e){
            String what = e.getActionCommand().toString();
            System.err.println("you pressed button "+what);
	    GraphCanvas_.setCurrentLabel(what);
            GraphCanvas_.setCurrentShape(currModules.getShape(what,dirName));
            GraphCanvas_.setCurrentDir(dirName);
            Event ee = new Event(this,0,Event.MOUSE_DOWN,-100,-100,0,0);
            GraphCanvas_.mouseDown(ee,-100,-100);    
          }
      };

        for (ii=0;ii<nbuttons;ii++) {
          moduleName = (String)ModList.elementAt(ii);
          buttonsM[ii]=new Button(moduleName);
          buttonsM[ii].addActionListener(QSlistener);
          PanelM[i].add(buttonsM[ii]);           
	} 

      Modules.add(dname,PanelM[i]);
      }

      dirName = currModules.getDirName(0);


      Creator.add(BorderLayout.CENTER,Modules);

      ActionCards.add("Edit", Creator); 

      Executor = new CPanel(12,"aga.npac.syr.edu");

      ActionCards.add("Run", Executor);

      Panel Savior = new Panel();
      Savior.add(new Label("Save panel goes here"));

      ActionCards.add("Save", Savior);

      Panel Loader = new Panel();
      Loader.add(new Label("Loader Panel goes here"));

      ActionCards.add("Load", Loader);

      Panel Exitor = new Panel();
      Exitor.add(new Label("Exitor Panel goes here"));

      ActionCards.add("Exit", Exitor);

      Panel Stopper = new Panel();
      Stopper.add(new Label("Stopper Panel goes here"));

      ActionCards.add("Stop", Stopper);

      add(BorderLayout.CENTER, ActionCards);
   }
   public void showContents() {
      card.last(Modules);
   }
   public void showContents(String what) {
      card.show(Modules,what);
   }

   public void showActionCard (String what) {
      Acard.show(ActionCards,what);
   }

   public void actionPerformed(ActionEvent e) {;}
   public void itemStateChanged(ItemEvent e) {;}

}


